package com.uca;

import com.uca.dao._Initializer;
import com.uca.gui.*;
import com.uca.core.*;
import com.uca.entity.*;
import java.sql.*;
import java.util.*;
import static spark.Spark.*;

public class StartServer {

    //.\gradlew run

    public static boolean authentified = false;

    public static void displayLocalHost(int portNb, String suffix)
    {
        System.out.println("http://localhost:"+portNb+"/"+suffix);
    }
    public static void main(String[] args) {

        
        int portNb = 8081;
        //Configure Spark
        staticFiles.location("/static/");
        port(portNb);


        _Initializer.Init();

        //Defining our routes
        displayLocalHost(portNb, "users");
        get("/users", (req, res) -> {
            return UserGUI.getAllUsers();
        });

        displayLocalHost(portNb, "profs");
        get("/profs", (req, res) -> {
            if (authentified)
            {
                return ProfGUI.getAllProfs();
            }
            else
            {
                res.redirect("/login");
                return null;
            }
            
        });

        post("/profs/delete",(req,res) -> {
            ProfGUI.delete(req.queryParams("id"));
            res.redirect("/profs");
            return null;
        });


        displayLocalHost(portNb, "login");
        get("/login",(req,res)->{
            return LoginGUI.getConnectionPage();
        });

        post("/login",(req,res)->{
            String username = req.queryParams("userName");
            String password = req.queryParams("password");
            List<ProfEntity> profs = Core.Prof.getAll();
            ProfEntity found = null;
            for (ProfEntity prof: profs) {
                if (prof.getUserName().compareTo(username) == 0){
                    found = prof;
                    break;
                }
            }
            if (found != null) {
                if (found.getPassword().compareTo(password) == 0) {
                    authentified = true;
                    res.redirect("/profs");
                    System.out.println(found);
                    return null;
                }
            }
            
            return "<!DOCTYPE html><html>Incorrect</html>";
        });
        
    }
}